/* 
   * This file is part of the MGUI library
   * Copyright 1996-1998 Vincenzo Morello
 */
#include <stdlib.h>

#include "mgui.hpp"

SUB_Shell(CdShell);
SUB_PushButton(CdQuitButton);
SUB_MenuItem(CdQuitItem);

void CdShell::
onWMClose(void)
{
    unrealize();
    MMessageDialog("", "Done", "Ok", NULL);
    delete this;

  CmAppl: :end(0);
}

void CdQuitButton::
onActivate(void)
{
    CmShell *shell = getShell();

    shell->unrealize();
    MMessageDialog("", "Quitting", "Ok", NULL);

  CmAppl: :end(0);
}

void CdQuitItem::
onActivate(void)
{
    MMessageDialog("", "Quitting", "Ok", NULL);

  CmAppl: :end(0);
}

void CmAppl::
start(int argc, char **argv)
{
    CdShell *shell;
    CmLabel *label;
    CmScrolledForm *sform;
    CmColForm *cform;
    CmRowForm *rform;
    CmPushButton *pb;
    CmColor red(255, 0, 0);
    CmColor green(0, 255, 0);
    CmImage *paulina = new CmImage("paulina.bmp");

    MLogInit(3, 10, 5, 80, 60, "mguipp.log");
    shell = new CdShell("Shell title", SF_NO_MAXIMIZE);
    shell->enableOnWMClose();

    CmMenu *menu = new CmMenu(shell, HELV_LARGE);
    MLog(1, "at line %d", __LINE__);
    CmPullDown *pd = new CmPullDown(menu, "File");
    MLog(1, "at line %d", __LINE__);
    new CdQuitItem(pd, "Quit");
    MLog(1, "at line %d", __LINE__);
    sform = new CmScrolledForm(shell, 20, 80);
    cform = new CmColForm(sform);
    rform = new CmRowForm(cform);
    label = new CmLabel(rform, "Label 1");
    label = new CmLabel(rform, "Label 2");
    rform = new CmRowForm(cform);
    label = new CmLabel(rform, "Label 3", HELV_LARGE);
    label = new CmLabel(rform, "Label 4");
    label->setFont(TIMES_LARGE);
    cform = new CmColForm(shell);
    new CmPixmap(cform, paulina);
    new CmPushButton(cform, "normal.bmp", "armed.bmp");

    paulina->install();
    pb = new CdQuitButton(shell, "Quit");
    pb->enableOnActivate();
    pb->setColor(&red, &green);
    new CmSFile(shell, __FILE__, DEFAULT_FONT, 4);
    shell->realize();

    MMainLoop();
}
